const needle = require('needle');

module.exports = {
   get: {
     send: (url) => {
         var sendedURL;
         if(url.includes("?")){
            var splitURL = url.split("?");
            sendedURL = splitURL[0];
            var queries = splitURL[1];
            var parsedQueries = queries.split("&");
            var jsonString = "{";
            for(let i = 0; i < parsedQueries.length; i++){
            var key = parsedQueries[i].split("=")[0];
            var val = parsedQueries[i].split("=")[1];
            val = val.replace(/[+]/g," ").replace(/20%/g," ").replace(/40%/g,"  ").replace(/60%/g,"   ");
            jsonString = jsonString + '"'+key+'"' +":"+ '"'+val+'"' + ",";
            };
            jsonString = jsonString.slice(0,-1);
            jsonString = jsonString + '}';
            var jsonParse = JSON.parse(jsonString);
         }else{
            sendedURL = url;
         }
         var uri = url;
         needle.get(uri, function(error, response) {
            if(response){
               if (!error && response.statusCode == 200){
                  console.log('\n')
                  console.log("GET request successful for " + sendedURL)
                  console.log("Status: " + response.statusCode + "\n")
                  if(url.includes("?")){
                     console.log("---------- DATAS ---------");
                     console.log(jsonParse)
                     console.log('\n')
                  }
               }else if(response.statusCode == 404){
                  console.log("ERROR: Page not found");
                  console.log("Status: " + response.statusCode + "\n")
               }else{
                  console.log(error)
               }
            }else{
               console.log("ERROR: Page not found");
               console.log("Status: 404");
            }
         });
      },
      response: (url) => {
         var sendedURL;
         if(url.includes("?")){
            var splitURL = url.split("?");
            sendedURL = splitURL[0];
            var queries = splitURL[1];
            var parsedQueries = queries.split("&");
            var jsonString = "{";
            for(let i = 0; i < parsedQueries.length; i++){
            var key = parsedQueries[i].split("=")[0];
            var val = parsedQueries[i].split("=")[1];
            val = val.replace(/[+]/g," ").replace(/20%/g," ").replace(/40%/g,"  ").replace(/60%/g,"   ");
            jsonString = jsonString + '"'+key+'"' +":"+ '"'+val+'"' + ",";
            };
            jsonString = jsonString.slice(0,-1);
            jsonString = jsonString + '}';
            var jsonParse = JSON.parse(jsonString);
         }else{
            sendedURL = url;
         }
         var uri = url;
         needle.get(uri, function(error, response) {
            if(response){
               if (!error && response.statusCode == 200){
                  return response.body;
               }else{
                  return error;
               }
            }else{
               return error;
            }
         });
      }
     },
     post: {
      send: (url,data) => {
         if(data){
            var datas = data;
         }else{
            datas = {};
         }
         needle.post(url, datas, {json:true}, function(error, response) {
            if(response){
               if (!error && response.statusCode == 200){
                  console.log('\n')
                  console.log("POST request successful for " + url)
                  console.log("Status: " + response.statusCode + "\n")
               }else if(response.statusCode == 404){
                  console.log("ERROR: Page not found");
                  console.log("Status: " + response.statusCode + "\n")
               }else{
                  console.log(error)
               }
            }else{
               console.log("ERROR: Page not found");
               console.log("Status: 404");
            }
         });
      },
      response: (url,data) => {
         var datas = data;
         needle.post(url, datas, {json:true}, function(error, response) {
            if(response){
               if(response){
                  if (!error && response.statusCode == 200){
                     return response.body;
                  }else if(response.statusCode == 404){
                     return 'Page not found';
                  }else{
                     return error;
                  }
               }else{
                  return error;
               }
         }
      })
    }
   }
}
